# frozen_string_literal: true

# --------------------------------------------- #
# Author: [Patrick W. <"Sickday@pm.me">] ------ #
# InitDate: [3/3/20] ------------------------- #
# --------------------------------------------- #

module Strum::Server::Packet
  ##
  # The Payload of this Packet.
  class Payload
    include Strum::Internal::Generic

    def initialize(data)
      self[:Buffer] = data ? data : Async::IO::Buffer.new
    end

    ##
    # Returns the current body of this packet.
    def build
      self[:Buffer]
    end

    ##
    # Writes data to this Packet's body
    def write(data)
      self[:Buffer] << [data].pack('C*')
    end

    alias_method :<<, :write
  end
end
